tm-mh-e 7.71 Reference Manual (English Version)
***********************************************

   This file documents tm-mh-e, a MIME extension for GNUS.

What is tm-mh-e?
****************

   *tm-mh-e* is a mh-e (see (mh-e)) extender to use MIME (see
MIME (tm-en)) feature using tm (see tm-kernel (tm-en)).

   tm-mh-e extends following features:

   * automatic MIME preview using tm-view (see (tm-view-en))

   * composing MIME message using tm-edit (see (tm-edit-en))

Extension for MH-Folder mode
****************************

`M-t'
     Toggle whether to do automatic MIME preview or not.

`v'
     Enter `mime/viewer-mode' to view a message.

`.'
     Display current message.

`,'
     Display current message with showing all fields.

`M-,'
     Display current "raw" message.

   mime/viewer-mode (see mime/viewer-mode (tm-view-en)) is a
major-mode to view and navigate MIME message.  In this mode, you can
move in a message or play a content, interactively.

Inline display for MIME message
*******************************

   *automatic MIME preview* feature is available in tm-mh-e.  In
automatic MIME preview mode, when reading an article in MH-Folder mode
(see Reading Mail (mh-e)), tm-mh-e displays preview buffer processed
by tm-view (see (tm-view-en)) instead of raw show buffer.

   Therefore if an article is encoded by Base64 (see Base64 (tm-en))
or Quoted-Printable (see Quoted-Printable (tm-en)), a decoded
article is displayed.  Or rich text article, such as text/enriched
(see text/enriched (tm-en)) format, is automatic formated.  Of
course, multipart (see multipart (tm-en)) article is dealt with
correctly.

   In addition, in *XEmacs*, images are displayed in preview buffer as
same as text.

   Different from using metamail, speaker does not roar just then read
an article includes audio content, video player does not play just then
read an article includes video content, it does not do anonymous ftp
(see ftp (tm-en)) or send mail when read an article includes
external-message.  These contents are played when you do decoding
command in preview buffer.

   However if you use a slow machine, or are just really impatient, you
can stop automatic MIME preview.

 - Variable: tm-mh-e/automatic-mime-preview
     If it is not `nil', tm-mh-e is in automatic MIME preview mode.

Internationalization
********************

   For emacs variants includes mule feature, such as MULE (see
MULE (tm-en)), XEmacs/mule and Emacs/mule(*1), tm-mh-e supports
code-conversion by MIME charset (see MIME charset (tm-en)).

*[Memo]*
     (*1) It means next generation of Emacs includes mule features.  Now
     (October 1996), HANDA Ken'ichi and RMS are developing it.

   Detail of code conversion is following:

  1. If a part of a MIME message has charset parameter of Content-Type
     field (see Content-Type field (tm-en)), it is code-converted by
     the MIME charset.

  2. encoded-word (see encoded-word (tm-en)) are code-converted by
     their specified MIME charset (see MIME charset (tm-en)).

  3. When there are no specified MIME charset, such as message header
     or non-MIME message, they are code-converted by
     `default-mime-charset' in Summary Buffer.

Don't use MIME charset
======================

   If MTA (see MTA (tm-en)) convert character encoding of messages
from network code to local code, such as EUC or Shift_JIS, MIME charset
does not work, so tm-mh-e can not display correct message.  It is quite
evil environment.  It does not break only MIME charset, but also
electric signature by PGP.

   If you can manage your environment, you should fix it.  Otherwise you
should persuade the administration.

   Unfortunately you are in such environment and you can not it,
following descriptions may be available.

for non-MIME message or non-charset
-----------------------------------

   For non-MIME message, please set the character encoding to variable
`default-mime-charset'.  For example, if you use Japanese EUC:

     (setq default-mime-charset 'euc-japan)

To disable MIME charset
-----------------------

   If for a text part specified MIME charset (see MIME charset (tm-en)),
one way is to set variable
`mime-charset-coding-system-alist' to specify the coding-system
corresponding the primary MIME charset.  For example, to specify
`*sjis*' or `*euc-japan*' as `iso-2022-jp'.  However it breaks texts
encoded by Base64 or Quoted-Printable.

   So it is better to redefine function
`tm-mh-e/decode-charset-buffer'.  For example, if your MTA converts
iso-2022-jp to Japanese EUC, following definition may work:

     (defun tm-mh-e/decode-charset-buffer (charset &optional encoding)
       (decode-mime-charset-region (point-min)(point-max) 'euc-japan)
       )

Composing MIME message
**********************

   If using mime-setup (see mime-setup (tm-en)), you can edit MIME
message in MH-Letter mode (see Draft Editing (mh-e)) using tm-edit
(see (tm-edit-en)).

   In addition, `f' is used for message/rfc822 (see
message/rfc822 (tm-en)) style forwarding instead of RFC 934 (see
RFC 934 (tm-en)) style forwarding.

Variable Index
**************